package org.jboss.qa.brms;

import org.guvnor.rest.client.JobResult;

public class NotSuccessException extends Exception {

    private static final long serialVersionUID = 1L;

    private JobResult jobResult;

    public NotSuccessException(JobResult result) {
        this(result, "Job was not successful; the result is '" + result.getResult() + "' with status "
                + result.getStatus().name());
    }

    public NotSuccessException(JobResult result, String message) {
        super(message);
        this.jobResult = result;
    }

    public NotSuccessException(JobResult result, String message, Throwable ex) {
        super(message, ex);
        this.jobResult = result;
    }

    public JobResult getJobResult() {
        return jobResult;
    }

}
