package org.jboss.qa.brms;

import java.util.Collection;
import org.guvnor.rest.client.JobRequest;
import org.guvnor.rest.client.JobResult;
import org.guvnor.rest.client.OrganizationalUnit;
import org.guvnor.rest.client.ProjectResponse;
import org.guvnor.rest.client.RepositoryResponse;
import org.kie.services.client.serialization.jaxb.impl.deploy.JaxbDeploymentJobResult;
import org.kie.services.client.serialization.jaxb.impl.deploy.JaxbDeploymentUnit;

public interface WorkbenchClient {

    public JobResult checkJobStatus(String jobId) throws NotSuccessException;
    
    public RepositoryResponse getRepository(String repo) throws NotSuccessException;

    public JobRequest deleteRepository(String repo) throws NotSuccessException;

    public JobRequest newRepository(String repo, String orgUnit) throws NotSuccessException;
    
    public Collection<RepositoryResponse> getRepositories() throws NotSuccessException;
    
    public JobRequest createRepository(String repo, String cloneRepoUrl, String orgUnit) throws NotSuccessException;

    public JobRequest addRepositoryToOrganizationalUnit(String organizationalUnit, String repo)
        throws NotSuccessException;

    public JobRequest createOrganizationalUnit(String name, String owner, String... repositories)
        throws NotSuccessException;

    public JobRequest deleteOrganizationalUnit(String organizationalUnit) throws NotSuccessException;

    public Collection<OrganizationalUnit> getOrganizationalUnits() throws NotSuccessException;

    public OrganizationalUnit getOrganizationalUnit(String organizationalUnit) throws NotSuccessException;

    public JobRequest removeRepositoryFromOrganizationalUnit(String organizationalUnit, String repo)
        throws NotSuccessException;

    public JobRequest removeOrganizationalUnit(String organizationalUnit) throws NotSuccessException;
    
    public JobRequest createProject(String repo, String project, String groupId, String version, String description) throws NotSuccessException;
    
    public Collection<ProjectResponse> getAllProjects(String repo);
    
    public JobRequest deleteProject(String repo, String project) throws NotSuccessException;

    public JobRequest compileProject(String repo, String project) throws NotSuccessException;

    public JobRequest installProject(String repo, String project) throws NotSuccessException;

    public JobRequest testProject(String repo, String project) throws NotSuccessException;

    public JobRequest deployProject(String repo, String project) throws NotSuccessException;
    
    public JaxbDeploymentJobResult createDeploymentUnit(String deploymentId, String strategy) 
            throws NotSuccessException;
    
    public JaxbDeploymentJobResult createDeploymentUnit(String deploymentId, String strategy, String kBase, String kSession) 
            throws NotSuccessException;
    
    public JaxbDeploymentUnit getDeploymentUnit(String deploymentId) throws NotSuccessException;
    
    public JaxbDeploymentJobResult removeDeploymentUnit(String deploymentId) throws NotSuccessException;

}
