package org.jboss.qa.brms;

import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

public class TestParameters {
    public static final String PARAM_PORT_BASE = "port.base";
    public static final String PARAM_PORT_OFFSET = "port.offset";
    public static final String PARAM_HOST = "host";
    public static final String PARAM_CTX = "app.ctx";
    public static final String PARAM_USER = "user";
    public static final String PARAM_PASSWORD = "password";
    
    private static final Properties testParams = load();

    public static String get(final String key) {
        return testParams.getProperty(key);
    }
    
    private static synchronized Properties load() {
        Properties params = new Properties();
        InputStream is = TestParameters.class.getResourceAsStream("/test-config.properties");
        try {
            params.load(is);
            return params;
        } catch (IOException ex) {
            throw new RuntimeException("failed to setup test parameters", ex);
        } finally {
            try {
                is.close();
            } catch (IOException ex) {
                System.out.println("Unable to close input stream.");
                ex.printStackTrace();
            }
        }
    }
}
